diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
index 7207c4478..27f8f0081 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCalendar.java
@@ -17,9 +17,9 @@ public class DynamicTextureCalendar extends DynamicTextureAbstractClock {
 		double d = 0.0;
 		if (minecraft.theWorld != null && minecraft.thePlayer != null)
 		{
-			if (minecraft.theWorld.seasonManager instanceof SeasonManagerCycle)
+			if (minecraft.theWorld.getSeasonManager() instanceof SeasonManagerCycle)
 			{
-				SeasonManagerCycle cycleManager = (SeasonManagerCycle) minecraft.theWorld.seasonManager;
+				SeasonManagerCycle cycleManager = (SeasonManagerCycle) minecraft.theWorld.getSeasonManager();
 				float f = cycleManager.getYearProgress() - 0.25f;
 				d = f * Math.PI * 2;
 			}
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 14e31b55e..7d9717daf 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -163,8 +163,7 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
             }
         }
     }
-
-    protected void renderSpecials(EntityPlayer entity, float f)
+    protected void renderSpecials(EntityPlayer entity, float partialTick)
     {
         if (Minecraft.getMinecraft(this).thePlayer.getGamemode() == Gamemode.spectator && entity.getGamemode() == Gamemode.spectator){
             GL11.glColor4f(1f, 1f, 1f, 0.25f);
@@ -196,36 +195,25 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
     	if(renderCape) {
             GL11.glPushMatrix();
             GL11.glTranslatef(0.0F, 0.0F, 0.125F);
-            double d = (entity.field_20066_r + (entity.field_20063_u - entity.field_20066_r) * (double)f) - (entity.xo + (entity.x - entity.xo) * (double)f);
-            double d1 = (entity.field_20065_s + (entity.field_20062_v - entity.field_20065_s) * (double)f) - (entity.yo + (entity.y - entity.yo) * (double)f);
-            double d2 = (entity.field_20064_t + (entity.field_20061_w - entity.field_20064_t) * (double)f) - (entity.zo + (entity.z - entity.zo) * (double)f);
-            float f8 = entity.prevRenderYawOffset + (entity.renderYawOffset - entity.prevRenderYawOffset) * f;
-            double d3 = MathHelper.sin((f8 * 3.141593F) / 180F);
-            double d4 = -MathHelper.cos((f8 * 3.141593F) / 180F);
-            float f9 = (float)d1 * 10F;
-            if(f9 < -6F)
-            {
-                f9 = -6F;
-            }
-            if(f9 > 32F)
-            {
-                f9 = 32F;
-            }
-            float f10 = (float)(d * d3 + d2 * d4) * 100F;
-            float f11 = (float)(d * d4 - d2 * d3) * 100F;
-            if(f10 < 0.0F)
-            {
-                f10 = 0.0F;
-            }
-            float f12 = entity.field_775_e + (entity.field_774_f - entity.field_775_e) * f;
-            f9 += MathHelper.sin((entity.walkDistO + (entity.walkDist - entity.walkDistO) * f) * 6F) * 32F * f12;
+            float yawOff = entity.prevRenderYawOffset + (entity.renderYawOffset - entity.prevRenderYawOffset) * partialTick;
+            float bodyAngle = 5;
             if(entity.isSneaking())
             {
-                f9 += 25F;
+                bodyAngle += 25F;
             }
-            GL11.glRotatef(6F + f10 / 2.0F + f9, 1.0F, 0.0F, 0.0F);
-            GL11.glRotatef(f11 / 2.0F, 0.0F, 0.0F, 1.0F);
-            GL11.glRotatef(-f11 / 2.0F, 0.0F, 1.0F, 0.0F);
+            double _xd = entity.xdO + (entity.xd - entity.xdO) * partialTick;
+            double _yd = Math.min(entity.ydO + (entity.yd - entity.ydO) * partialTick, 0);
+            double _zd = entity.zd0 + (entity.zd - entity.zd0) * partialTick;
+            double vel = -1/(3 * Math.hypot(_xd, _zd) + 1) + 1;
+            double moveAng = Math.atan2(_xd, _zd);
+            double yawRad = Math.toRadians(yawOff);
+            double multiplier = 1 - Math.abs((((Math.cos(yawRad) + 1) - (Math.cos(moveAng) + 1) + 2)/2) -1); // Hell code, basically measures how similar the angle you're facing is to the angle you're moving, with it returning 1 if the same angle and 0 if opposite angles
+            entity.wobbleTimer += (float) (((entity.tickCount + partialTick) - entity.lastRenderTick)/(30 - 29 * MathHelper.clamp(vel, 0, 1)));
+            entity.lastRenderTick = entity.tickCount;
+            double wobble = Math.sin(entity.wobbleTimer) * (1.5 + 4.5 * vel * multiplier);
+            GL11.glRotatef((float) MathHelper.clamp((MathHelper.clamp(bodyAngle + vel * 100 * multiplier, bodyAngle, 100f) + wobble) - _yd * 60, 0, 180), 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(0, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(0, 0.0F, 1.0F, 0.0F);
             GL11.glRotatef(180F, 0.0F, 1.0F, 0.0F);
             modelBipedMain.renderCloak(0.0625F);
             GL11.glPopMatrix();
@@ -313,9 +301,9 @@ public class PlayerRenderer extends LivingRenderer<EntityPlayer>
     }
 
     @Override
-    protected void renderEquippedItems(EntityPlayer entity, float f)
+    protected void renderEquippedItems(EntityPlayer entity, float partialTick)
     {
-        renderSpecials(entity, f);
+        renderSpecials(entity, partialTick);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
index 7e0675f5a..0152599b4 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDoorPainted.java
@@ -7,6 +7,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemDye;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 
 public class ItemModelDoorPainted extends ItemModelStandard{
     public static IconCoordinate[] doorIcons = new IconCoordinate[16];
@@ -18,7 +19,7 @@ public class ItemModelDoorPainted extends ItemModelStandard{
     public ItemModelDoorPainted(Item item) {
         super(item, null);
     }
-    public IconCoordinate getIcon(Entity entity, ItemStack itemStack){
+    public @NotNull IconCoordinate getIcon(Entity entity, ItemStack itemStack){
         int meta = itemStack.getMetadata();
         return doorIcons[MathHelper.clamp(meta, 0, 15)];
     }
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
index 0cb51fe93..c93496e82 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelStandard.java
@@ -37,8 +37,10 @@ import static org.lwjgl.opengl.GL11.glScaled;
 import static org.lwjgl.opengl.GL11.glTranslated;
 
 public class ItemModelStandard extends ItemModel{
+    public static final IconCoordinate ITEM_TEXTURE_MISSING = TextureRegistry.getTexture("minecraft:item/texture_missing");
+    public static final IconCoordinate ITEM_TEXTURE_UNASSIGNED = TextureRegistry.getTexture("minecraft:item/texture_unassigned");
     protected boolean useColor = true;
-    public IconCoordinate icon;
+    public IconCoordinate icon = ITEM_TEXTURE_UNASSIGNED;
     protected boolean bFull3D = false;
     protected boolean rotateWhenRendering = false;
     protected boolean pointInfrontOfPlayer = false;
@@ -115,21 +117,19 @@ public class ItemModelStandard extends ItemModel{
         glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         glEnable(GL_CULL_FACE);
         IconCoordinate textureIndex = getIcon(mc.thePlayer, itemStack);
-        if (textureIndex != null) {
-            GL11.glDisable(GL_LIGHTING);
-            textureIndex.parentAtlas.bindTexture();
-            if (useColor) {
-                final int color = getColor(itemStack);
-                final float r = (color >> 16 & 0xff) / 255F;
-                final float g = (color >> 8 & 0xff) / 255F;
-                final float b = (color & 0xff) / 255F;
-                GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-            } else {
-                GL11.glColor4f(brightness, brightness, brightness, alpha);
-            }
-            renderTexturedQuad(tessellator, x, y, textureIndex);
-            glEnable(GL_LIGHTING);
+        GL11.glDisable(GL_LIGHTING);
+        textureIndex.parentAtlas.bindTexture();
+        if (useColor) {
+            final int color = getColor(itemStack);
+            final float r = (color >> 16 & 0xff) / 255F;
+            final float g = (color >> 8 & 0xff) / 255F;
+            final float b = (color & 0xff) / 255F;
+            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
+        } else {
+            GL11.glColor4f(brightness, brightness, brightness, alpha);
         }
+        renderTexturedQuad(tessellator, x, y, textureIndex);
+        glEnable(GL_LIGHTING);
         glEnable(GL_CULL_FACE);
         glDisable(GL11.GL_BLEND);
     }
diff --git a/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java b/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
index b4e92176a..28abaeede 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
+++ b/src/main/java/net/minecraft/client/render/stitcher/AtlasStitcher.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render.stitcher;
 import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.util.helper.Textures;
+import org.jetbrains.annotations.Nullable;
 
 import java.awt.*;
 import java.awt.image.BufferedImage;
@@ -18,16 +19,19 @@ public class AtlasStitcher {
     public Map<String, IconCoordinate> textureMap = new HashMap<>();
     public BufferedImage atlas;
     public final String directoryPath;
+    @Nullable
+    public final String defaultTexture;
     private int atlasWidth;
     private int atlasHeight;
     private double invWidth;
     private double invHeight;
     private final int textureId;
     private final boolean mipmap;
-    public AtlasStitcher(String directoryPath, boolean mipmap){
+    public AtlasStitcher(String directoryPath, boolean mipmap, @Nullable String defaultTexture){
         this.directoryPath = directoryPath;
         this.textureId = GLAllocation.generateTexture();
         this.mipmap = mipmap;
+        this.defaultTexture = defaultTexture;
     }
     protected IconCoordinate getTexture(String key){
         if (textureMap.containsKey(key)) return textureMap.get(key);
@@ -49,9 +53,12 @@ public class AtlasStitcher {
         List<IconCoordinate> coordinateList = new ArrayList<>(textureMap.values());
         for (IconCoordinate coordinate : coordinateList){
             BufferedImage image = Textures.readImage(mc.texturePackList.getResourceAsStream(coordinate.sourceImage));
-            if (image == null) image = Textures.missingTexture;
-            if (image == Textures.missingTexture){
+            if (image == null || image == Textures.missingTexture){
                 System.out.println(coordinate.sourceImage + " could not be found!");
+                if (defaultTexture != null){
+                    image = Textures.readImage(mc.texturePackList.getResourceAsStream(defaultTexture));
+                }
+                if (image == null) image = Textures.missingTexture; // If this ever happens I'll be very sad
             }
             coordinate.setImage(image);
             coordinate.setDimension(image.getWidth(), image.getHeight());
diff --git a/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java b/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
index 3979a5400..100726206 100644
--- a/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
+++ b/src/main/java/net/minecraft/client/render/stitcher/TextureRegistry.java
@@ -17,10 +17,10 @@ import java.util.stream.Stream;
 
 public class TextureRegistry {
     public static HashMap<String, AtlasStitcher> stitcherMap = new HashMap<>();
-    public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", true));
-    public static AtlasStitcher itemAtlas =  register("item", new AtlasStitcher("textures/item", true));
-    public static AtlasStitcher particleAtlas = register("particle", new AtlasStitcher("textures/particle", false));
-    public static AtlasStitcher artAtlas = register("art", new AtlasStitcher("textures/art", false));
+    public static AtlasStitcher blockAtlas = register("block", new AtlasStitcher("textures/block", true, "/assets/minecraft/textures/block/texture_missing.png"));
+    public static AtlasStitcher itemAtlas =  register("item", new AtlasStitcher("textures/item", true, "/assets/minecraft/textures/item/texture_missing.png"));
+    public static AtlasStitcher particleAtlas = register("particle", new AtlasStitcher("textures/particle", false, null));
+    public static AtlasStitcher artAtlas = register("art", new AtlasStitcher("textures/art", false, null));
 
     public static IconCoordinate getTexture(String key){
         if (key == null) return null;
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index 7cbf94aef..aa159027a 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -16,7 +16,7 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
     @Override
     public void onWorldChanged(World world)
     {
-        renderBlocks = new RenderBlocks(world, world);
+        renderBlocks = new RenderBlocks(world);
     }
     @Override
     public void doRender(Tessellator tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
diff --git a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
index ac66cc9a4..a1c191c8e 100644
--- a/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
+++ b/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererPiston.java
@@ -35,7 +35,7 @@ public class TileEntityRendererPiston extends TileEntityRenderer<TileEntityPisto
     @Override
 	public void onWorldChanged(World world)
     {
-        renderBlocks = new RenderBlocks(world, world);
+        renderBlocks = new RenderBlocks(world);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index 6d59b85e5..094edce19 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -2,7 +2,6 @@ package net.minecraft.core.block;
 
 
 import com.b100.utils.Utils;
-import net.minecraft.core.Global;
 import net.minecraft.core.HitResult;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.entity.TileEntity;
@@ -37,7 +36,6 @@ import net.minecraft.core.item.block.ItemBlockPiston;
 import net.minecraft.core.item.block.ItemBlockSlab;
 import net.minecraft.core.item.block.ItemBlockSlabPainted;
 import net.minecraft.core.item.block.ItemBlockStairsPainted;
-import net.minecraft.core.item.tool.ItemTool;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.BoundingVolume;
@@ -264,7 +262,7 @@ public class Block
         return atlasIndices[side.getId()];
     }
 
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return AABB.getBoundingBoxFromPool((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
     }
@@ -288,7 +286,7 @@ public class Block
         return true;
     }
 
-    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return AABB.getBoundingBoxFromPool((double)x + minX, (double)y + minY, (double)z + minZ, (double)x + maxX, (double)y + maxY, (double)z + maxZ);
     }
@@ -493,11 +491,10 @@ public class Block
     {
     }
 
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
     }
-
-    public void setBlockBoundsBasedOnSide(World world, int x, int y, int z, Side side)
+    public void setBlockBoundsBasedOnSide(WorldSource world, int x, int y, int z, Side side)
     {
     }
 
@@ -1047,6 +1044,12 @@ public class Block
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
     public static final Block flowerRed = new BlockFlower("flower.red", 331).setKilledByWeather().withHardness(0.0F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+    public static final Block flowerPink = new BlockFlower("flower.pink", 332).setKilledByWeather().withHardness(0.0F)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+    public static final Block flowerPurple = new BlockFlower("flower.purple", 333).setKilledByWeather().withHardness(0.0F)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
+    public static final Block flowerLightBlue = new BlockFlower("flower.lightblue", 334).setKilledByWeather().withHardness(0.0F)
+            .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
 
     public static final Block mushroomBrown = new BlockMushroom("mushroom.brown", 340).withHardness(0.0F).withLightEmission(0.125F)
             .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLANTABLE_IN_JAR);
diff --git a/src/main/java/net/minecraft/core/block/BlockAlgae.java b/src/main/java/net/minecraft/core/block/BlockAlgae.java
index a09563cba..0cddb5cf9 100644
--- a/src/main/java/net/minecraft/core/block/BlockAlgae.java
+++ b/src/main/java/net/minecraft/core/block/BlockAlgae.java
@@ -40,19 +40,19 @@ public class BlockAlgae extends Block
     public boolean canPlaceBlockAt(World world, int x, int y, int z)
     {
         int blockId = world.getBlockId(x, y, z);
-        return blockId == 0 && Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER);
+        return blockId == 0 && Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER) && world.getBlockMetadata(x, y -1, z) == 0;
     }
 
     @Override
     public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(world.getBlockId(x, y -1, z)!= Block.fluidWaterStill.id){
+        if(!Block.hasTag(world.getBlockId(x, y - 1, z), BlockTags.IS_WATER) || world.getBlockMetadata(x, y -1, z) != 0){
             world.setBlock(x, y, z,0);
         }
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockBasket.java b/src/main/java/net/minecraft/core/block/BlockBasket.java
index 8d5ea72cf..92a4b67f7 100644
--- a/src/main/java/net/minecraft/core/block/BlockBasket.java
+++ b/src/main/java/net/minecraft/core/block/BlockBasket.java
@@ -42,7 +42,7 @@ public class BlockBasket extends BlockTileEntity
         return new TileEntityBasket();
     }
 
-    public int getFillLevel(final World world, final int x, final int y, final int z)
+    public int getFillLevel(final WorldSource world, final int x, final int y, final int z)
     {
         final TileEntityBasket te = (TileEntityBasket) world.getBlockTileEntity(x, y, z);
 
diff --git a/src/main/java/net/minecraft/core/block/BlockBed.java b/src/main/java/net/minecraft/core/block/BlockBed.java
index 009303fe8..96c218a3a 100644
--- a/src/main/java/net/minecraft/core/block/BlockBed.java
+++ b/src/main/java/net/minecraft/core/block/BlockBed.java
@@ -7,9 +7,8 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.EnumSleepStatus;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.block.logic.BedDirections;
-import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 
 public class BlockBed extends Block {
@@ -70,7 +69,7 @@ public class BlockBed extends Block {
 			if(player1 == null) {
 				setBedOccupied(world, x, y, z, false);
 			} else {
-				player.addChatMessage("bed.occupied");
+				player.sendTranslatedChatMessage("bed.occupied");
 				return true;
 			}
 		}
@@ -95,7 +94,7 @@ public class BlockBed extends Block {
 	}
 
 	@Override
-	public void setBlockBoundsBasedOnState(World world, int x, int y, int z) {
+	public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
 		setBounds();
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/BlockButton.java b/src/main/java/net/minecraft/core/block/BlockButton.java
index 4cddadbe6..7f06a83a9 100644
--- a/src/main/java/net/minecraft/core/block/BlockButton.java
+++ b/src/main/java/net/minecraft/core/block/BlockButton.java
@@ -26,7 +26,7 @@ public class BlockButton extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
@@ -176,7 +176,7 @@ public class BlockButton extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         int i1 = l & 7;
diff --git a/src/main/java/net/minecraft/core/block/BlockCactus.java b/src/main/java/net/minecraft/core/block/BlockCactus.java
index 37a366e5a..76535c0ae 100644
--- a/src/main/java/net/minecraft/core/block/BlockCactus.java
+++ b/src/main/java/net/minecraft/core/block/BlockCactus.java
@@ -10,7 +10,6 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
@@ -71,14 +70,14 @@ public class BlockCactus extends Block implements IBonemealable
 
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float f = 0.0625F;
         return AABB.getBoundingBoxFromPool((float) x + f, y, (float) z + f, (float)(x + 1) - f, (float)(y + 1) - f, (float)(z + 1) - f);
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         float f = 0.0625F;
         return AABB.getBoundingBoxFromPool((float) x + f, y, (float) z + f, (float)(x + 1) - f, y + 1, (float)(z + 1) - f);
diff --git a/src/main/java/net/minecraft/core/block/BlockCake.java b/src/main/java/net/minecraft/core/block/BlockCake.java
index a1eb3db8a..70938f019 100644
--- a/src/main/java/net/minecraft/core/block/BlockCake.java
+++ b/src/main/java/net/minecraft/core/block/BlockCake.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, IBlockAccess, World, 
@@ -34,7 +35,7 @@ public class BlockCake extends Block
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z)
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         float f = 0.0625F;
@@ -44,7 +45,7 @@ public class BlockCake extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         float f = 0.0625F;
@@ -54,7 +55,7 @@ public class BlockCake extends Block
     }
 
     @Override
-    public AABB getSelectedBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getSelectedBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         int l = world.getBlockMetadata(x, y, z);
         float f = 0.0625F;
diff --git a/src/main/java/net/minecraft/core/block/BlockCandle.java b/src/main/java/net/minecraft/core/block/BlockCandle.java
index bc5923791..9000dc5b2 100644
--- a/src/main/java/net/minecraft/core/block/BlockCandle.java
+++ b/src/main/java/net/minecraft/core/block/BlockCandle.java
@@ -6,6 +6,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -21,7 +22,7 @@ public class BlockCandle extends Block
     }
 
     @Override
-    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockCobweb.java b/src/main/java/net/minecraft/core/block/BlockCobweb.java
index df28eb48b..745993810 100644
--- a/src/main/java/net/minecraft/core/block/BlockCobweb.java
+++ b/src/main/java/net/minecraft/core/block/BlockCobweb.java
@@ -8,6 +8,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, Entity, Item, 
@@ -51,7 +52,7 @@ public class BlockCobweb extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return null;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java b/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
index 429f5ea8f..e2b126ae8 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
+++ b/src/main/java/net/minecraft/core/block/BlockCropsPumpkin.java
@@ -9,6 +9,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
@@ -19,7 +20,7 @@ public class BlockCropsPumpkin
     }
 
     @Override
-    public void setBlockBoundsBasedOnState(World world, int x, int y, int z) {
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
         int meta = world.getBlockMetadata(x, y, z);
         float onePix = 1.0F / 16.0F;
         float size = 0.0f;
@@ -100,8 +101,8 @@ public class BlockCropsPumpkin
         if(diagNeighbor || xNeighbor && zNeighbor) {
             growthRate /= 2.0F;
         }
-        if (world.seasonManager.getCurrentSeason() != null) {
-            growthRate *= world.seasonManager.getCurrentSeason().cropGrowthFactor;
+        if (world.getSeasonManager().getCurrentSeason() != null) {
+            growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
         }
         return growthRate;
     }
@@ -111,7 +112,7 @@ public class BlockCropsPumpkin
         return new ItemStack[] { new ItemStack(Item.seedsPumpkin, 1)};
     }
 
-    public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z) {
+    public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         setBlockBoundsBasedOnState(world, x, y, z);
         int meta = world.getBlockMetadata(x, y, z);
         if (meta == 0) {
diff --git a/src/main/java/net/minecraft/core/block/BlockCropsWheat.java b/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
index 696cb9d0d..7d82dfdcf 100644
--- a/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
+++ b/src/main/java/net/minecraft/core/block/BlockCropsWheat.java
@@ -96,9 +96,9 @@ public class BlockCropsWheat extends BlockFlower implements IBonemealable
         {
             growthRate /= 2.0F;
         }
-        if (world.seasonManager.getCurrentSeason() != null)
+        if (world.getSeasonManager().getCurrentSeason() != null)
         {
-            growthRate *= world.seasonManager.getCurrentSeason().cropGrowthFactor;
+            growthRate *= world.getSeasonManager().getCurrentSeason().cropGrowthFactor;
         }
         return growthRate;
     }
diff --git a/src/main/java/net/minecraft/core/block/BlockDirtPath.java b/src/main/java/net/minecraft/core/block/BlockDirtPath.java
index 0db1de332..0ac7d9545 100644
--- a/src/main/java/net/minecraft/core/block/BlockDirtPath.java
+++ b/src/main/java/net/minecraft/core/block/BlockDirtPath.java
@@ -6,6 +6,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 //updated
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, AxisAlignedBB, World,
@@ -22,7 +23,7 @@ public class BlockDirtPath extends Block
     }
 
     @Override
-	public AABB getCollisionBoundingBoxFromPool(World world, int x, int y, int z)
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
         return AABB.getBoundingBoxFromPool(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
     }
